from pi_pico_nfc_grove import *
from machine import Pin, UART

# Création d'un objet uart0   
uart0 = UART(0, baudrate=115200)                                        
uart0.init(115200, bits=8, parity=None, stop=1, tx=Pin(0), rx=Pin(1) )  # paramètres de la liaison série

# création d'un objet Pn532_uart
nfc = Pn532_uart(uart0)

# Affichage version firmware
ic, ver, rev, support = nfc.firmware_version
print("PN532 version {0}.{1}".format(ver, rev))

# Configuration du PN532 pour communiquer avec les cartes MiFare
# Carte de 16 secteurs (0 à 15) de 4 blocs (de 0 à 63)
nfc.SAM_configuration()

# Attente carte valable présente
print("Attente carte NFC", end="")
uid = None
while uid is None:   
    uid = nfc.read_passive_target(timeout=500)
    print(".", end="")
print("")
print("Trouvé carte UID = ", [(hex(i)) for i in uid])

# Lecture du 1er bloc du secteur 2 (bloc 8)
# Il faut s'authentifier sur un secteur pour y accéder avec la clé par défaut 0xFFFFFFFFFFFF
cle = b"\xFF\xFF\xFF\xFF\xFF\xFF"
authentification = nfc.mifare_classic_authenticate_block(uid, 8, MIFARE_CMD_AUTH_B, cle)
print([hex(x) for x in nfc.mifare_classic_read_block(8)])

# Ecritue du 1er bloc du secteur 2 (bloc 8)
# Il faut s'authentifier sur un secteur pour y accéder avec la clé par défaut 0xFFFFFFFFFFFF
# Attention, destruction du secteur si écriture sur le 4ème bloc (bloc 3, 7, 11, 15...)
data = bytearray(16)
data[0:16] = b"\x08\xFF\x00\xFF\xFF\x60\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
nfc.mifare_classic_write_block(8, data)
print(nfc.mifare_classic_read_block(8))
print([hex(x) for x in nfc.mifare_classic_read_block(8)])




